/*
 *  Copyright (C) 2005-2007 Jiri Slaby <jirislaby@gmail.com>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 */

#ifndef BACKPORT_H_FILE
#define BACKPORT_H_FILE

#include <linux/kernel.h>
#include <linux/version.h>

#define PH_CLASSTYPE	class

#if LINUX_VERSION_CODE <= KERNEL_VERSION(2, 6, 14) && \
	LINUX_VERSION_CODE > KERNEL_VERSION(2, 6, 12)
#define class_device_create(cls, pnt, devt, dev, fmt...) \
		class_device_create(cls, devt, dev, fmt)
#endif

#if LINUX_VERSION_CODE <= KERNEL_VERSION(2, 6, 13)
#include <linux/slab.h>
#include <linux/types.h>
static inline void *kzalloc(size_t size, unsigned int __nocast flags)
{
	void *ret = kmalloc(size, flags);
	if (ret)
		memset(ret, 0, size);
	return ret;
}
#endif

#if LINUX_VERSION_CODE <= KERNEL_VERSION(2, 6, 12)
#undef PH_CLASSTYPE
#define PH_CLASSTYPE	class_simple
#define class_create(own, nam)	class_simple_create(own, nam)
#define class_destroy(cls)	class_simple_destroy(cls)
#define class_device_create(cls, pnt, devt, dev, fmt...) \
		class_simple_device_add(cls, devt, dev, fmt)
#define class_device_destroy(cls, devt) \
		class_simple_device_remove(devt)
#define class_create_file(cls, att) ({ (void)att; (void)cls; 0; })
#define class_remove_file(cls, att) ({ (void)att; (void)cls; 0; })
#endif

#ifndef BIT
#define BIT(x)	(1UL << (x))
#endif

#endif
