#include <err.h>
#include <fcntl.h>
#include <poll.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <linux/input.h>

static unsigned int read_it(int fd)
{
	struct input_event ev;

	read(fd, &ev, sizeof(ev));
	printf("event: %lu/%lu, %x, %x, %d\n", ev.time.tv_sec, ev.time.tv_usec, ev.type, ev.code, ev.value);
	return ev.type == EV_SYN && ev.code == SYN_CONFIG;
}

int main(void)
{
	struct input_event iev = { .type = EV_FF, .value = 1 };
	struct ff_effect eff = { .type = FF_RAW, .id = -1 };
	struct pollfd ufd;
	char *dev = "/dev/input/event2";
	unsigned int a, syn;
	int fd, retval;

	fd = open(dev, O_RDWR);
	if (fd < 0)
		err(1, "%s", dev);

	if (ioctl(fd, EVIOCSFF, &eff) < 0)
		err(2, "EVIOCSFF");

	puts("polling");
	iev.code = eff.id;
	printf("Starting eff. no %u\n", eff.id);
	if (write(fd, &iev, sizeof(iev)) < 0)
		err(7, "iev");
	for (a = 0; a < 1000; a++) {
new_poll:
		ufd.fd = fd;
		ufd.events = POLLIN | POLLERR | POLLNVAL;
		retval = poll(&ufd, 1, -1);
                if (retval < 0)
                        err(3, "poll failed");
                if (ufd.revents & POLLNVAL)
                        errx(4, "poll failed - POLLNVAL");
                if (ufd.revents & POLLERR)
                        errx(5, "poll failed - POLLERR");

		syn = 0;
		while (ufd.revents & POLLIN) {
			syn += read_it(fd);
			ufd.fd = fd;
			ufd.events = POLLIN | POLLERR | POLLNVAL;
			if (poll(&ufd, 1, 0) < 0)
				err(8, "poll failed");
		}

		if (!syn) {
			puts("BAD EVENT");
			goto new_poll;
		}

		eff.u.ff_raw[0]++;
		if (ioctl(fd, EVIOCSFF, &eff) < 0)
			err(6, "EVIOCSFF");
	}

	sleep(2);

	close(fd);

	return 0;
}
