#include <math.h>

#include "libphantom.h"

float *phm_to_spherical(float in[3], float out[3])
{
	float x = in[0];
	float y = in[1];
	float z = in[2];
	float xx = x * x;
	float yy = y * y;
	float zz = z * z;

	/* ro */
	out[0] = sqrt(xx + yy + zz);

	/* phi */
	out[1] = asin(y / sqrt(xx + yy));

	/* theta */
	out[2] = acos(z / out[0]);

	return out;
}

float *phm_to_cartesian(float in[3], float out[3])
{
	float x = in[0];
	float y = in[1];
	float z = in[2];

	out[0] = x * sin(z) * cos(y);
	out[1] = x * sin(z) * sin(y);
	out[2] = x * cos(z);

	return out;
}

float *phm_interpolate(float inB[3], float inE[3], float out[3], float alpha)
{
	unsigned int i;

	for (i = 0; i < 3; i++)
		out[i] = (1.0 - alpha) * inB[i] + alpha * inE[i];

	return out;
}
