#include <stdio.h>
#include <stdlib.h>
#include <err.h>

#include <libphantom.h>

static void print_usage(const char *progname)
{
	printf("%s [device name]\n\n", progname);
	printf("\t default device name is /dev/phantom0\n");
	exit(1);
}

int main(int argc, char **argv)
{
	struct phantom_device *dev;
	char *devname = "/dev/phantom0";

	if (argc > 2)
		print_usage(*argv);

	if (argc == 2)
		devname = argv[1];

	dev = phm_open(devname);
	if (dev == NULL)
		errx(2, "Can't open phantom!\n");

	if (phm_reset(dev)) { /* this sould never happen :) */
		phm_stop(dev);
		errx(3, "Can't reset phantom!\n");
	}

	phm_stop(dev);

	return 0;
}
