//-----------------------------------------------------------//
//							     //
//       mr_thread.cpp		ver. 3.0		     //
//							     //
//       Pavel Kolcarek, kolcarek@fi.muni.cz		     //
//							     //
//-----------------------------------------------------------//

#include <iostream>
#include "mr_thread.h"

  ////////////////////////////////////////////////////////////
 //
//   class CThread

CThread::CThread()
{
	// thread identification
	thread_id = 0;

	// initialize mutex
	pthread_mutex_init(&thread_lock, NULL);
}

CThread::~CThread()
{
	pthread_mutex_destroy(&thread_lock);
}

int CThread::start_loop()
{
	int code;

	code = pthread_create(&thread_id, NULL, &init_thread, this);

	if (code)
		cerr << "creating thread failed: " << code << endl;

	return code;
}

/* static */ void *CThread::init_thread(void *pthis)
{
	// static member functions do not have access to the this
	// pointer of a c++ object. that why we have to typecast
	// data and pass it to the thread

	CThread *p = (CThread *) pthis;
	p->run_thread();

	return NULL;
}

void CThread::lock_me()
{
	pthread_mutex_lock(&thread_lock);
}

void CThread::unlock_me()
{
	pthread_mutex_unlock(&thread_lock);
}

void CThread::run_thread()
{
	// we have nothing to do here...
	// this is only abstract virtual method
}

bool CThread::is_running()
{
	return loop_is_running;
}
