//-----------------------------------------------------------//
//							     //
//       ph_lib_lowlevel.cpp	ver. 3.0		     //
//							     //
//-----------------------------------------------------------//

#include <stdio.h>
#include <stdlib.h>

#include <unistd.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <libphantom.h>
#include "ph_lib_lowlevel.h"

static struct phantom_device *dev;

int ph_open(int rate, struct phantom_device **global)
{
	dev = phm_open("/dev/phantom0");
	if (dev == NULL) {
		fprintf(stderr, "Can't open phantom!\n");
		return 1;
	}

	if (phm_start(dev, rate)) {
		fprintf(stderr, "Can't start phantom!\n");
		goto err_close;
	}

	dev->iterations = 1;
	*global = dev;

	return 0;
err_close:
	phm_stop(dev);
	return 2;
}

void ph_close()
{
	phm_stop(dev);
}

int st_wait(struct phantom_info **pi)
{
	phm_wait(dev);
	*pi = phm_switch(dev);

	return dev->status & PHM_ERROR;
}
