//-----------------------------------------------------------//
//							     //
//       ph_lib_ws.cpp        ver. 3.0			     //
//							     //
//-----------------------------------------------------------//
#include "ph_lib_ws.h"

bool IsOut(gmVector3 Pos, double boundary)
{
	double d;
	bool out = false;
	gmVector3 tPos = Pos;
	gmVector3 tmp(PH_ZERO_X_DISTANCE, PH_ZERO_Y_DISTANCE,
		      PH_ZERO_Z_DISTANCE);

	tPos -= tmp;
	d = Pos.length();

	if ((d - boundary) < PH_MIN_BORDER_RADIUS) {
		out = true;
	}
	if ((d + boundary) > PH_MAX_BORDER_RADIUS) {
		out = true;
	}

	tPos += tmp;

	tmp.assign(PH_MIN_X, PH_MIN_Y, PH_MIN_Z);
	for (int i = 0; i < 3; i++) {
		if (tPos[i] < tmp[i] + boundary) {
			out = true;
		}
	}

	tmp.assign(PH_MAX_X, PH_MAX_Y, PH_MAX_Z);
	for (int i = 0; i < 3; i++) {
		if (tPos[i] > tmp[i] - boundary) {
			out = true;
		}
	}

	return out;
}

bool ProjectionToWorkSpace(gmVector3 & Pos, double boundary)
{
	double d;
	bool out = false;
	gmVector3 tmp(PH_ZERO_X_DISTANCE, PH_ZERO_Y_DISTANCE,
		      PH_ZERO_Z_DISTANCE);

	Pos -= tmp;
	d = Pos.length();

	if ((d - boundary) < PH_MIN_BORDER_RADIUS) {
		Pos *= PH_MIN_BORDER_RADIUS / (d - boundary);
		out = true;
	}
	if ((d + boundary) > PH_MAX_BORDER_RADIUS) {
		Pos *= PH_MAX_BORDER_RADIUS / (d + boundary);
		out = true;
	}

	Pos += tmp;

	tmp.assign(PH_MIN_X, PH_MIN_Y, PH_MIN_Z);
	for (int i = 0; i < 3; i++) {
		if (Pos[i] < tmp[i] + boundary) {
			Pos[i] = tmp[i] - boundary;
			out = true;
		}
	}

	tmp.assign(PH_MAX_X, PH_MAX_Y, PH_MAX_Z);
	for (int i = 0; i < 3; i++) {
		if (Pos[i] > tmp[i] - boundary) {
			Pos[i] = tmp[i] - boundary;
			out = true;
		}
	}

	return out;
}
