//-----------------------------------------------------------//
//							     //
//       ph_lib_ws.h		ver. 3.0		     //
//							     //
//       this module contains basic functions for work       //
//       with phantom working space			     //
//							     //
//-----------------------------------------------------------//

#ifndef __PH_LIB_WS_H__
#define __PH_LIB_WS_H__

#include "ph_lib_def.h"
#include <gm.h>
/*
#define PH_MIN_X -0.25
#define PH_MAX_X  0.25

#define PH_MIN_Y -0.12
#define PH_MAX_Y +0.4

#define PH_MIN_Z -0.45
#define PH_MAX_Z  0.124
*/

#define PH_ZERO_X_DISTANCE	0
#define PH_ZERO_Y_DISTANCE	0.14
#define PH_ZERO_Z_DISTANCE	-0.13
#define PH_MIN_BORDER_RADIUS	0.13
#define PH_MAX_BORDER_RADIUS	0.232

/**
 * true if Pos is out from ws
 *
 * @param Pos is not changed
 * @param boundary distance from real boundary of ws
 */
bool IsOut(gmVector3 Pos, double boundary = 0.0);
/**
 * @param Pos is projected to ws
 */
bool ProjectionToWorkSpace(gmVector3 & Pos, double boundary = 0.0);

#endif
